﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reactive.Linq;
using System.Reactive.Concurrency;


namespace GroupByDemo
{
    class Program
    {
        static void Main(string[] args)
        {
            //var names = (from n in new string[] { "James", "Lisa", "John", "Tom", "Lola", "Tim", "Jessica", "Avery" }
            //             select n).ToObservable();
            //names.GroupBy(n => n.StartsWith("J"))
            //    .Subscribe(g => g.Count().Subscribe(
            //        c => Console.WriteLine(c)));

            //var s = (from x in new int[] { 2, 4, 6, 8, 10, 12, 14, 16 } select x)
            //    .ToObservable();
            //s.Skip(4).Subscribe(Console.WriteLine);

            //var oQuery = Observable.Repeat("Test", 5);
            //oQuery.Subscribe(Console.WriteLine,
            //    e => Console.WriteLine(e.Message),
            //    () => Console.WriteLine("Complete"));

            //var s1 = (from n in Enumerable.Range(1, 10) select n).ToObservable();
            //var s2 = (from n in Enumerable.Range(100, 10) select n).ToObservable();
            //s1.Concat(s2).Subscribe(Console.WriteLine);

            //var s1 = (from n in new int[] { 1, 3, 5, 7 } select n).ToObservable();
            //var s2 = (from n in new int[] { 2, 4, 6, 8 } select n).ToObservable();
            //var result = s1.Zip(s2, (x, y) => new { x, y });
            //result.Subscribe(v => Console.Write(" {0} {1} ", v.x, v.y));

            var query = (from n in new int[] {3,5,7,9,11,13,8,15,19 } select n);
            var oQuery = query.ToObservable(Scheduler.NewThread)
                .Select(i => 10 / (i % 2))
                .Catch((Exception e) => Observable.Return(-1))
                .Subscribe(Console.WriteLine);

            Console.ReadKey();
        }
    }
}
